{#-#####################################################################
 # Template for /etc/rc.conf.d/netif
  ###################################################################-#}
{#-=====================================================================
 # Imports
 #===================================================================-#}
{%- import "common.j2"                  as config     with context -%}
{%- import "freebsd_rc/inc/helpers.j2"  as helpers    with context -%}
{%- import "freebsd_rc/inc/ifconfig.j2" as ifconfig   with context -%}
{%- import "freebsd_rc/inc/rcvars.j2"   as rcvars     with context -%}

{#-=====================================================================
 # Render
 # ---------------------------------------------------------------------
 # Render the configuration of all defined network interfaces.
 #===================================================================-#}
{%- macro render(indexes) -%}

  {%- set line_buffer = [] -%}

  {#--------------------------------------------------------------------
   # Common variables
   #------------------------------------------------------------------#}

  {{ '# ' ~ ansible_managed ~ "\n\n" }}

  {#- Cloned interfaces -#}
  {%- set cloned_interfaces =
      rcvars.render_cloned_interfaces(indexes) -%}
  {%- if cloned_interfaces -%}
    {{ line_buffer.append(cloned_interfaces) }}
  {%- endif -%}

  {#- IPv6 Customer Premise Equipements WAN interfaces -#}
  {%- set cpe_interfaces =
      rcvars.render_ipv6_cpe_wanif(indexes) -%}
  {%- if cpe_interfaces -%}
    {{ line_buffer.append(cpe_interfaces) }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Interface variables
   #------------------------------------------------------------------#}
  {%- for uid,interface in indexes['valid_interfaces'].items() -%}

    {#- Set interface creation arguments
     #
     #  We show this one first because create_args_x vars are processed
     #  **before** interface renaming.
    -#}
    {%- set create_args_var =
      rcvars.render_create_args_x(interface, indexes)-%}
    {%- if create_args_var -%}
      {{ line_buffer.append(create_args_var) }}
    {%- endif -%}

    {#- Set interface name and description -#}
    {%- set rename_var =
      rcvars.render_ifconfig_x_name(interface, indexes) -%}
    {%- set descr_var =
      rcvars.render_ifconfig_x_descr(interface, indexes) -%}
    {%- if rename_var -%}
      {{ line_buffer.append(rename_var) }}
    {%- endif -%}
    {%- if descr_var -%}
      {{ line_buffer.append(descr_var) }}
    {%- endif -%}

    {#- Set ifconfig inet (link + IPv4) options -#}
    {%- set inet_var =
      rcvars.render_ifconfig_x(interface, indexes) -%}
    {%- if inet_var -%}
      {{ line_buffer.append(inet_var) }}
    {%- endif -%}

    {#- Set ifconfig inet (IPv4) aliases -#}
    {%- set inet_alias_vars =
      rcvars.render_ifconfig_x_aliases(interface, indexes) -%}
    {%- if inet_alias_vars -%}
      {{ line_buffer.append(inet_alias_vars) }}
    {%- endif -%}

    {#- Set ifconfig inet6 (IPv6) options -#}
    {%- set inet6_var =
      rcvars.render_ifconfig_x_inet6(interface, indexes) -%}
    {%- if inet6_var -%}
      {{ line_buffer.append(inet6_var) }}
    {%- endif -%}

  {%- endfor -%}

  {#- Dump line buffer -#}
  {{ line_buffer | join() }}

{%- endmacro -%}

{{ render(role__sys_net_interfaces__indexes) }}
